<HTML>                                
<HEAD>
<meta http-equiv="content-type" content="text/html; charset=<!.GetCharSet>">
</meta>

  <TITLE><!.ProductName></TITLE>

<link rel='stylesheet' type='text/css' href='/diagnostics/stylesheets/main.css'>

</HEAD>

<BODY>

<SCRIPT LANGUAGE="JavaScript">

//
// --- instead of using a strict array, how about a singly linked list to keep track of our business?
//


//
//     Device related vars
//
var DeviceList = new Array(); // selected devices
var Selected = new Array();   // currently selected device // 0 = no 1 = yes -1 = disabled
    var no = 0;
    var yes = 1;
    var deleted = -1;
 
var Icon = new Array();       
var NumDevices = 0;           // total selected devices
    var NotFound = 999;

//
//     Test related vars
//
var TestList = new Array(); // test names (caption)
var ShowParams = new Array();
var RunTest  = new Array(); // test selected (true/false)
var TestDevice = new Array(); // links to associated device (name or index?)

var TestCom = new Array();
var TestDev = new Array();
var TestNam = new Array();

var XMLString = new Array(); 
var NumTests = 0; // total number of available tests
var TestsSelected = 0;

//
//     Test parameter related vars
//
var ParamName = new Array(); // test parameter names
var ParamCaption = new Array(); 
var ParamDescription = new Array(); 
var ParamType = new Array(); 
var ParamMin = new Array();  
var ParamMax = new Array();  
var ParamDefault = new Array(); 
var ParamValue = new Array(); 

var ParamTest = new Array(); // link to associated test (index)
var NumParams = 0; // total number of available parameters

//
// other vars
//
var Time=0;
var Loops=1;


function changeTime()
{
  if (document.getElementById)
    Time = document.getElementById( "time" ).value;
}

function changeLoops()
{
  if (document.getElementById)
    Loops = document.getElementById( "loops" ).value;
}


//
// 
//        Device Functions
//
//

function showDevices()
{
//
// this function generates the html for the second column, and inserts it in the 'cart' tag in scripter.cpp
//

  var displayoutput = "";

  for (var i = 0; i < NumDevices; i++)
  {
    if (Selected[i] != deleted)
    {
//      alert (Selected[i]);
      if (Selected[i] == yes)
        displayoutput += "<div style=\"background-color:navy; color:white;\">";
      else // selected == no
        displayoutput += "<div onclick='SelectMe(" + i + ");'>"; 
      displayoutput += "<img style=\"vertical-align: middle;\" src=\"images/" + Icon[i] + "\">";
      displayoutput += DeviceList[i] + "</div>\n";
    }
  }

  displayoutput += "\n";

// can we somehow move this button to the bottom of the table?
  displayoutput += "<div><input type=button name=delete value='Remove Device' onclick='RemoveDevice();'></input></div>\n";


//
// *** UNCOMMENT THIS TO SEE WHAT THE CRACK IS GOING ON ***
//
//  alert(displayoutput);

  if(document.getElementById)
    document.getElementById('cart').innerHTML = displayoutput; 

  ConfigDevice();
}


function RemoveDevice()
{
// instead of actually deleting the devices, we just set a disabled flag for it and leave it there
// this takes out the labor of having to renumber devices and reassociate tests with devices
// which could get fairly complex

  if (NumDevices == 0)
    return;

  // find the currently selected device
  var index=NotFound;

  for (var z = 0; z < NumDevices; z++)
    if (Selected[z] == yes)
      index = z;  

  // set the device as deleted
  Selected[index] = deleted;

  // set all tests associated with this device to RunTest = false
  for (var i = 0; i < NumTests; i++)
    if (TestDevice[i] == index)
	{
	  if (RunTest[i] == true)
	  {
        TestsSelected--;
        RunTest[i] = false;
	  }
	}
  
  refreshTestListOutput(); // make sure our xml stuff is up to date
  showDevices();
}

function ConfigDevice()
{
//
// some stuff might go here
//
  showTests();    
}

function SelectMe(which)
{
//
// unset all set devices and select the clicked device as the SELECTED one
// leave disabled devices disabled
//
  for (var i = 0; i < NumDevices; i++)
    if (Selected[i] == yes)
      Selected[i] = no;

  Selected[which] = yes;
  showDevices();

}

function addDevice(Device, IconName)
{
  
  DeviceList[NumDevices] = Device;
  Icon[NumDevices] = IconName;
  NumDevices++;

  showDevices();
}




//
// 
//        Test Functions
//
//
function refreshTestListOutput()
{
//
// this is how to pass the data back into the elm application
// needs to be done AFTER the XML string is generated (by selecting all the test and parameters)
//

  var hiddenoutput = "";

  hiddenoutput += "<input type=hidden name=loops value=" + Loops + " >\n";
  hiddenoutput += "<input type=hidden name=time  value=" + Time  + " >\n";
  hiddenoutput += "<input type=hidden name=numTests value=" + TestsSelected + ">\n";

  var TestNumber = 0;
  for (var j = 0; j < NumTests; j++)
  {
    // find the tests that have been CHECKED and output the XML string
    if (RunTest[j] == true)
    {
      hiddenoutput += " <input type=hidden name=runTest" + TestNumber;
      hiddenoutput += " value=\"" + XMLString[j] + "\">\n";
      TestNumber++;
    }
  }


//
// UNCOMMENT THIS TO SEE WHAT KIND OF STUFF WE'RE PITCHIN AROUND
//
//  alert (hiddenoutput);

  if(document.getElementById)
    document.getElementById('ericfour').innerHTML = hiddenoutput; 

}

function addTest(TC, Device, TestName, TestCap)
{

  TestList[NumTests] = TestCap;

  //TestDevice[NumTests] = Device; // by name
  TestDevice[NumTests] = NumDevices - 1; // by index -- better approach

  TestCom[NumTests] = TC;
  TestDev[NumTests] = Device;
  TestNam[NumTests] = TestName;

  XMLString[NumTests] = "";

//  XMLString[NumTests]  = "<runTest component='" + TC;
//  XMLString[NumTests] += "' device='"           + Device;
//  XMLString[NumTests] += "' test='"             + TestName;
//  XMLString[NumTests] += "'/>";

  ShowParams[NumTests] = false; 
  RunTest[NumTests] = false;

  NumTests++;
}

function createXMLString(i) // i = test number
{
  XMLString[i]  = "<runTest component='" + TestCom[i];
  XMLString[i] += "' device='"           + TestDev[i];
  XMLString[i] += "' test='"             + TestNam[i];

  for (var y = 0; y < NumParams; y++)
  {
    if (ParamTest[y] == i) // if we've found the corresponding parameters with this test ...
    {
      XMLString[i] += "' " + ParamName[y];
      XMLString[i] += "='" + ParamValue[y];
    }
  }

  XMLString[i] += "'/>";

  refreshTestListOutput();

//  alert ( XMLString[i] );
}


function showTests()
{
//
// this function generates the html for the third column, inputs it in the div tag 'tests' in scripter.cpp
//
  
  if (NumDevices == 0)
  {
    if(document.getElementById)
      document.getElementById('tests').innerHTML = ""; 

    return;
  }

  // find the currently highlighted device from column two.  stores it in index.
  var index=NotFound;
  for (var z = 0; z < NumDevices; z++)
  {
    if (Selected[z] == yes)
      index = z;  
  }

  if (index == NotFound) 
  {
    if(document.getElementById)
      document.getElementById('tests').innerHTML = ""; 

    return;
  }

//  alert(index);

  // show what the current device is, third column
  var displayoutput= "";
  displayoutput += "<div><b> ";
  displayoutput += DeviceList[index];
  displayoutput += " configuration: </b></div>\n";
                                   
  for (var y = 0; y < NumTests; y++)
  {
    createXMLString(y);

    if (TestDevice[y] == index)
    {
       displayoutput += "<div><input type=checkbox name=\"";
       displayoutput += TestList[y] + "\" ";

       if (RunTest[y] == true)
         displayoutput += " checked ";
       
       displayoutput += "onclick='SelectTest(";
       displayoutput += index + ",";
       displayoutput += y + ");' > ";

       displayoutput += "<span onclick='OpenParam(" + y + ")'>";

       if (ShowParams[y] == true) // should be true
         displayoutput += "<img src='littledash.gif'> ";
       else
         displayoutput += "<img src='littlex.gif'> ";
      
       displayoutput += "</span>";

       displayoutput += TestList[y];
       displayoutput += "</div>\n"; 

       if (ShowParams[y] == true) // should be true
       {
         var atLeastOneOption = false;
         for (var yy= 0; yy < NumParams; yy++)
         {
           if (ParamTest[yy] == y)
           {
              atLeastOneOption = true;

			  displayoutput += "<div>&nbsp;&nbsp;&nbsp;&nbsp;";

              if (ParamType[yy] == "bool")
              {
                displayoutput += "<input name=";
                displayoutput += ParamName[yy] + yy;
                displayoutput += " type=checkbox ";

                if (ParamValue[yy] == 1)
                  displayoutput += " checked ";
											   
                displayoutput += "onclick='saveBoolParameter("
                displayoutput += yy;  // parameter number
                displayoutput += ",";
                displayoutput += y;   // test number
                displayoutput += ");'> ";
              }
			  else if (ParamType[yy] == "dword")
			  {
                displayoutput += "<input name=";
                displayoutput += ParamName[yy] + yy;
                displayoutput += " type=text size=9 value='";	 // need long field
                displayoutput += ParamValue[yy];
                displayoutput += "' onChange='saveParameter("
                displayoutput += yy;  // parameter number
                displayoutput += ",";
                displayoutput += y;   // test number
                displayoutput += ");'> ";
			  }
			  else
			  {
                displayoutput += "<input name=";
                displayoutput += ParamName[yy] + yy;
                displayoutput += " type=text size=3 value='";
                displayoutput += ParamValue[yy];
                displayoutput += "' onChange='saveParameter("
                displayoutput += yy;  // parameter number
                displayoutput += ",";
                displayoutput += y;   // test number
                displayoutput += ");'> ";
			  }


              displayoutput += ParamCaption[yy];
//              displayoutput += " (" + ParamType[yy] + ") ";
              displayoutput += "</div>";


           }
         }
         if (atLeastOneOption == false)
         {
            displayoutput += "<div>&nbsp;&nbsp;&nbsp;&nbsp;";
            displayoutput += "No options</div>";
         }
       }
    }   
  }

//
// UNCOMMENT THIS TO SEE WHAT THE CRACK IS GOING ON
//
//  alert (displayoutput);

  if(document.getElementById)
    document.getElementById('tests').innerHTML = displayoutput; 
}


function OpenParam(test)
{
  if (ShowParams[test] == true)
    ShowParams[test] = false;
  else
    ShowParams[test] = true;

  showTests();
}


function SelectTest(device, test)
{
  if (RunTest[test] == true)
  {
    TestsSelected--;
    RunTest[test] = false;
  }
  else
  {
    TestsSelected++;
    RunTest[test] = true;
  }
//
// UNCOMMENT THIS TO MAKE SURE TEST CHECKBOXES ARE TOGGLING
//
//  alert(RunTest[test]);
//  alert (device);
//  alert (test);

  refreshTestListOutput();

}


function addParameter(name, caption, description, type, defaultval)
{
  ParamName[NumParams] = name; 
  ParamCaption[NumParams] = caption;
  ParamDescription[NumParams] = description;
  ParamType[NumParams] = type;
//  ParamMin[NumParams] = min;
//  ParamMax[NumParams] = max; 
//  ParamDefault[NumParams] = defaultval;    
  ParamValue[NumParams] = defaultval;      
  ParamTest[NumParams] = NumTests - 1;
  NumParams++;
}

function saveParameter(prm, tst)
{
//  alert (ParamName[prm] + prm);
//  alert (document.getElementById( ParamName[prm] + prm ).value);

  if (document.getElementById)
    ParamValue[prm] = document.getElementById( ParamName[prm] + prm ).value;

  createXMLString(tst);

//  alert (ParamValue[prm]);
}

function saveBoolParameter(prm, tst) // do a TOGGLE
{
  if (ParamValue[prm] == 1)
    ParamValue[prm] = 0;
  else
    ParamValue[prm] = 1;

  createXMLString(tst);

//  alert (ParamValue[prm]);
}

</SCRIPT>

<table cellspacing="0" cellpadding="0" border="0" width=100% height=100%>
<tr><td colspan=2 align=left valign=top>

<!.Scripter>


</td></tr>
</table>
</BODY>

</HTML>
