#!/bin/sh

# 
# stop_diags.sh - Shut down the diagnostic ELM proxy gracefully
#
# Usage: stop_diags.sh
#

diagname="hpdiags"

pid=`ps -fu root | grep $diagname | grep -v grep | awk '($3==1) {print $2}'`
if test -n "$pid"
then
  echo -e "\n** stopping diagnostics ... **\n"
  kill -2 $pid
  while test -n "`ps -fu root | grep $diagname | grep -v grep`"
  do
    sleep 1
  done
  echo -e "\n** diagnostic server stopped **\n"
else
  echo -e "\n** diagnostic server is not running **\n"
fi

if test -n "$PHOENIX"
then
  cp /diags/html/diagnostics/eventlog.* /var/www/html 2>/dev/null
fi

